<template>
  <div>
    <tree
      ref="tree"
      v-model="modelTree"
      @tree:mounted="mounted($event)"
      :data="data"
      :filter="search"
      :options="treeOptions"
    />
  </div>
</template>
<style scoped>
.tree-size {
  overflow: auto;
  max-height: 440px;
  min-height: 440px;
}
</style>
<script>
const treeOptions = {
  filtering: true,
  propertyNames: {
    text: "nombre",
  },
  checkbox: true,
  filter: {
    emptyText: "Sin resultados",
    showChildren: false,
  },
};
export default {
  name: "Component-VistasPerfil",
  props: ["items", "values", "search"],
  data: () => ({
    data: [],
    allNodes: [],
    modelTree: null,
    nodeSelected: null,
    instanceTree: null,
  }),
  filters: {
    time(time) {
      return +time;
    },
  },
  watch: {
    modelTree(val) {
      let checkedNodes = val.checked;
      if (checkedNodes.length > 0) {
        let ids = [];
        checkedNodes.forEach((item) => {
          ids.push(item.id);
        });
        this.$emit("input", ids);
      } else {
        this.$emit("input", []);
      }
    },
    values(val) {
      if (val.length > 0) {
        this.checkedNodes();
      }
    },
  },
  computed: {
    treeOptions() {
      return treeOptions;
    },
  },
  methods: {
    mounted() {
      this.instanceTree = this.$refs.tree;
      this.getArbolVistas();
      if (this.values && this.values.length > 0) {
        this.checkedNodes();
      }
    },
    checkedNodes() {
      let nodes = this.instanceTree.findAll({});
      nodes.forEach((item) => {
        let checked =
          this.values.filter(
            (vista) => vista.idVista == item.id && item.children.length == 0
          ).length == 1;
        if (checked) {
          item.check();
        }
      });
    },
    getArbolVistas() {
      let data = this.items.map((item, index) => {
        return {
          id: item.idVista,
          idParent: item.idVistaPadre,
          text: item.nombre,
          data: item,
          state: { expanded: true },
        };
      });
      this.data = JSON.unflatten(data, "id", "idParent");
      this.data.forEach((item) => {
        if (item.idParent == 0) {
          item.state = {
            expanded: true,
            draggable: false,
          };
        }
        this.instanceTree.append(item);
      });
    },
  },
};
</script>
